' '********************************************************************************************
'		: This function requires JCT hardware that supports BargeIN and Echo Cancellation
' Description	: Ask the caller to reply to you prompt.  Allows BargeIN so caller can stop the prompt by talking.
'		: The recorded response can the be used to recognize what was said with the Recognize command
'		: See the folder "Speech Recognition and Text to Speech" in the Callmaster\DOC folder for more details
' File Type	: CallMaster script file by SpeechSoft, Inc. 05/10/05
' File Name	: Ask.bas
' Format	: Ask	<PlayFileName> <Recordfilename> <recordFileID>
'			PlayFileName	- [string,input] is name of the file with full path that has the aduio to pay first
'			RecordFilename	- [string,output] is name of the file with full path of the Audio Recording 
'					 
'			RecordFileID	- [integer,output] the file ID of the RecordFile above
' '*********************************************************************************************
Program

	Print "Ask Test Script started"

' Clear any DTMF if you want to tur off Touch Tone cut through leave out to allow cut through
'	Clear_DTMF

' Initialize variables - use a prompt number or any other audio recording file like an Audiotex Msg ID
' Prompt 515 is the Attendant ASR main menu. Yo can use any prompt number but use FIleIDtoName to get the filename with full path
	Prompt = 565

' Plays prompt 515 ASttendant main menu.
	PlayFile = ""
	FileIDToName PlayFile Prompt

' Play msg and records reply places the record file name and record File ID in the variables RecordFileName RecordFileID
	RecordFileName = ""
	RecordFileID = 0
	Ask PlayFile RecordFileName RecordFileID

	' print out the recorded file name and ID
	IntegerToString audiofileID RecordFileID
	ptext = "RecordFileName  = " & RecordFileName
	Print ptext
	ptext = "RecordFileID  = " & audiofileID
	Print ptext
	
' Check for Touch Tone response instead of speech
	TTInput = ""
	DIGITS = ""
	TMASK = ""
	NDIGITS = 1
	TIMEOUT = 0

	' Get caller's touch-tone input
	GetDTMF TTInput TMASK NDIGITS TIMEOUT

	If TTInput <> "" Then
		' Caller responded with Touch Tones just print them out and return
		ptext = "Tone response to ASK> " & TTInput
		Return 0
	Else
	EndIf

' Now setup for recognition of the recorded file 

	'XML File needs to be in the Callmaster\Data folder
	TexttoRecognize = "recognizetree.xml"
	WordCount = 0
	wValue = 0
	ASRType = "XMLFILE"
	'ASRType = "FILE"
	ASROK = 0

'Recognize The words in the TexttoRecognize field if they were spoken

	Recognize RecordFileName TexttoRecognize ASRType RecognizedWords WordCount wValue wValueString ASROK ResultTree

'Test validity of the recognition results 1-Pass, 0-Fail
	If ASROK = 0 Then
		Print " *** ASR Recognize failed!"
		RecognizedWords = " ** Failed ** "
	Else

' Print out the recogition results

		ptext = "ASR RecognizedWord = " & RecognizedWords
		Print ptext
		IntegerToString pvalue wValue 
		ptext = "ASR Result = " & pvalue 
		Print ptext
		IntegerToString pvalue WordCount
		ptext = "ASR WordCount = " & pvalue 
		Print ptext
		ptext = "ASR wValueString = " & wValueString
		Print ptext
		ptext = "Speech Recognition Result Tree> " & ResultTree
		Print ptext 

	EndIf


EndProgram
