Program

' '********************************************************************************************
' File Type	: CallMaster script file by SpeechSoft, Inc. 06/14/04
' File Name	: RecognizeAlpha.bas
' Format	: Recognize <AudioFileIn> <TexttoRecognize> <ASRType> <RecognizedWords> <WordCount> <wValue> <wValueString> <ASROK> 	
'			AudioFileIn 	- is name of file with path that has the recording
'			TexttoRecognize	- Contains the words to be recognized seperated by commas or 
'					  a file Name as determined by the Type parameter
'			ASRType		- TEXT|FILE|XMLFILE where 
'					  TEXT means the prior field has the actual word list, 
'				          FILE means it has a file name that has the list and 
'					  XMLFILE means it has a name of an XML file that has the grammar
'			RecognizedWords - The words that were recognized
'			WordCount 	- Number of words recognized
'			wValue 		- contains the recognized word/phrase position in the list or 
'					  the XML PropertyID of the word recognized
'			wValueString 	- Returns the XML VALSTR attribute for the recognizd words/Phrases.
'			ASROK 		- Returns the status of the recognize process. 1 - Pass or 0 - Fail.  
'					  Determines whether the returned values are valid.'
'
' Description	: recognizes a word or phrase on a recorded file
' '*********************************************************************************************

	Print "RecognizeAlpha Test Script started"

' Initialize variables
	Prompt = 100
	RecTime = 180
	t = "*"
	a = ""
	recfileid = 0

' Plays prompt 100 (Press * to stop recording) to instruct caller, Then.
' Records file and places speechfile id in integer variable recfileid.  

	Record recfileid Prompt RecTime a t e d
	IntegerToString audiofileID recfileid
	ptext = "fileID  = " & audiofileID
	Print ptext
	FileIDToName AudioFileIn recfileid

' Now setup for recognition of the recorded file

	'<AudioFileIn> 		- String -  The Text parameter contains the name of a ASCII file that has the words to recognize. 
	'				    After the function call it has the results of the recognition in text, 
	'				    null is nothing recognized.
	'<TexttoRecognize>	- String -  is a list of words seperated by commas or the name of a file containing the words seperated 
	'				    by commas or XML Grammar located in the Callmaster\data folder.
	'<ASRType> 		- String -  TEXT | FILE | XMLFILE - determines what the <TexttoRecognize> parameter contains, 
	'				    the words to recognize or, the name of a ASCII file that is to be recognized, 
	'				    or a file with xml grammar.
	'<RecognizedWords> 	- String -  The words that were recognized
	'<WordCount> 		- Integer - Number of words recognized
	'<wValue> 		- Integer - contains the recognized word/phrase position in the list or 
	'				    the XML PropertyID of the word recognized
	'<wValueString> 	- String -  Returns the XML VALSTR attribute for the recognizd words/Phrases.
	'<ASROK> 		- Integer - Returns the status of the recognize process. 1 - Pass or 0 - Fail.  
	'				    Determines whether the returned values are valid.

	TexttoRecognize = "CMAlpha.xml"
	ASRResult = 0
	ASRType = "XMLFILE"
	ASROK = 0

'Recognize The words in the Text field if they were spoken and print out the results

	Recognize AudioFileIn TexttoRecognize ASRType RecognizedWords WordCount wValue wValueString ASROK 

	If ASROK = 0 Then
		Print " *** ASR Recognize failed!"
		RecognizedWords = " ** Failed ** "
	Else

		ptext = "ASR RecognizedWord = " & RecognizedWords
		Print ptext
		IntegerToString pvalue wValue 
		ptext = "ASR Result = " & pvalue 
		Print ptext
		IntegerToString pvalue WordCount
		ptext = "ASR WordCount = " & pvalue 
		Print ptext
		ptext = "ASR wValueString = " & wValueString
		Print ptext
	EndIf

' Rename the audio file to send it to the SRAudioArchive folder

	newfile = "C:\Program Files\Callmaster\SRAudioArchive\"
	newfile = newfile & audiofileID
	newfile = newfile & " - "
	newfile = newfile & RecognizedWords
	newfile = newfile & ".wav"

	ptext = "Renaming audio file to " & newfile
	Print ptext

	FileRename AudioFileName newfile	

EndProgram
